EpiTicket/Models/Event.cs
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;

namespace EpiTicket.Models
{
    public class Event
    {
        [Key] public string EventId { get; set; }

        [Required] public string Name { get; set; }

        public string Poster { get; set; }
        public string Description { get; set; }

        [Required] public string Location { get; set; }

        [Required] public uint Capacity { get; set; }

        [Required] public float Price { get; set; }

        [Required] public DateTime StartDate { get; set; }

        [Required] public DateTime EndDate { get; set; }

        [Required]
        public int AssociationId { get; set; }
        public Association Organizer { get; set; }

        public List<Ticket> Tickets { get; set; }
    }
}

EpiTicket/Controllers/EventController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using CloudinaryDotNet;
using CloudinaryDotNet.Actions;
using EpiTicket.Data;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using Microsoft.EntityFrameworkCore;
using EpiTicket.Models;
using Cloudinary = EpiTicket.Data.Cloudinary;
using Microsoft.Extensions.Configuration;
using Microsoft.AspNetCore.Authorization;
using System.Diagnostics;

namespace EpiTicket.Controllers
{
    public class EventController : Controller
    {
        private readonly TicketContext _context;
        private readonly User _currentUser;
        private readonly Membership _currentUserMembership;
        private readonly IConfiguration _configuration;

        public EventController(TicketContext context, IConfiguration configuration)
        {
            _context = context;
            _configuration = configuration;
            if (User != null)
            {
                _currentUser = _context.Users.FirstOrDefault(m => m.UserName == User.Identity.Name);
                _currentUserMembership = _context.Membership.FirstOrDefault(m => m.User.UserName == User.Identity.Name);
            }
        }

        // GET: Event
        public async Task<IActionResult> Index()
        {
            var ticketContext = _context.Events.Include(e => e.Organizer);
            return View(await ticketContext.ToListAsync());
        }

        // GET: Event/Details/5
        public async Task<IActionResult> Details(string id)
        {
            if (id == null)
            {
                return NotFound();
            }

            var @event = await _context.Events
                .Include(e => e.Organizer)
                .FirstOrDefaultAsync(m => m.EventId == id);
            if (@event == null)
            {
                return NotFound();
            }

            ViewData["QRCode"] = QRCodeManager.Base64FromURL(_configuration["BASE_URL"] + Request.Path.Value);
            return View(@event);
        }

        // GET: Event/Create
        [Authorize]
        public IActionResult Create()
        {
            if ((_currentUserMembership != null && _currentUserMembership.role != Membership.RoleE.lambda) || User.IsInRole("Admin"))
            {
                ViewData["AssociationId"] = new SelectList(_context.Associations, "AssociationId", "Name");
                return View();
            }
            else
                return new ForbidResult();
        }

        // POST: Event/Create
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see http://go.microsoft.com/fwlink/?LinkId=317598.
        [Authorize]
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Create([Bind("EventId,Name,Poster,Description,Location,Capacity,Price,StartDate,EndDate,AssociationId")] Event @event)
        {
            if ((_currentUserMembership != null && _currentUserMembership.role != Membership.RoleE.lambda) || User.IsInRole("Admin"))
            {
                if (ModelState.IsValid)
                {
                    UploadImage(@event);
                    _context.Add(@event);
                    await _context.SaveChangesAsync();
                    return RedirectToAction(nameof(Index));
                }
                ViewData["AssociationId"] = new SelectList(_context.Associations, "AssociationId", "Name", @event.AssociationId);
                return View(@event);
            }
            else
                return new ForbidResult();
        }

        // GET: Event/Edit/5
        [Authorize]
        public async Task<IActionResult> Edit(string id)
        {
            if ((_currentUserMembership != null && _currentUserMembership.role != Membership.RoleE.lambda) || User.IsInRole("Admin"))
            {
                if (id == null)
                {
                    return NotFound();
                }

                var @event = await _context.Events.FindAsync(id);
                if (@event == null)
                {
                    return NotFound();
                }
                ViewData["AssociationId"] = new SelectList(_context.Associations, "AssociationId", "Name", @event.AssociationId);
                return View(@event);
            }
            else
                return new ForbidResult();
        }

        // POST: Event/Edit/5
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see http://go.microsoft.com/fwlink/?LinkId=317598.
        [Authorize]
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Edit(string id, [Bind("EventId,Name,Poster,Description,Location,Capacity,Price,StartDate,EndDate,AssociationId")] Event @event)
        {
            if (id != @event.EventId)
            {
                return NotFound();
            }

            if ((_currentUserMembership != null && _currentUserMembership.role != Membership.RoleE.lambda) || User.IsInRole("Admin"))
            {
                if (ModelState.IsValid)
                {
                    UploadImage(@event);
                    var existing = await _context.Events.AsNoTracking().FirstOrDefaultAsync(e => e.EventId == @event.EventId);
                    @event.Poster = @event.Poster ?? existing.Poster;
                    try
                    {
                        _context.Update(@event);
                        await _context.SaveChangesAsync();
                    }
                    catch (DbUpdateConcurrencyException)
                    {
                        if (!EventExists(@event.EventId))
                        {
                            return NotFound();
                        }
                        else
                        {
                            throw;
                        }
                    }
                    return RedirectToAction(nameof(Index));
                }
                ViewData["AssociationId"] = new SelectList(_context.Associations, "AssociationId", "Name", @event.AssociationId);
                return View(@event);
            }
            else
                return new ForbidResult();
        }

        // GET: Event/Delete/5
        [Authorize]
        public async Task<IActionResult> Delete(string id)
        {
            if ((_currentUserMembership != null && _currentUserMembership.role != Membership.RoleE.lambda) || User.IsInRole("Admin"))
            {
                if (id == null)
                {
                    return NotFound();
                }

                var @event = await _context.Events
                    .Include(e => e.Organizer)
                    .FirstOrDefaultAsync(m => m.EventId == id);
                if (@event == null)
                {
                    return NotFound();
                }

                return View(@event);
            }
            else
                return new ForbidResult();
        }

        // POST: Event/Delete/5
        [Authorize]
        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> DeleteConfirmed(string id)
        {
            if ((_currentUserMembership != null && _currentUserMembership.role != Membership.RoleE.lambda) || User.IsInRole("Admin"))
            {
                var @event = await _context.Events.FindAsync(id);
                _context.Events.Remove(@event);
                await _context.SaveChangesAsync();
                return RedirectToAction(nameof(Index));
            }
            else
                return new ForbidResult();
        }

        private bool EventExists(string id)
        {
            return _context.Events.Any(e => e.EventId == id);
        }
        
        private void UploadImage(Event @event)
        {
            var poster = Request.Form.Files.GetFile("Poster");
            if (poster == null) { return; }

            var response = Cloudinary.Instance.Upload(new ImageUploadParams {
                File = new FileDescription(poster.FileName, poster.OpenReadStream()),
                PublicId = $"EpiTicket/Events/{@event.Name}-poster"
            });

            @event.Poster = response.PublicId;
        }
    }
}

EpiTicket/Controllers/PurchaseController.cs
using System;
using System.Linq;
using System.Threading.Tasks;
using EpiTicket.Models;
using Microsoft.AspNetCore.Mvc;
using Microsoft.EntityFrameworkCore;
using Stripe;

namespace EpiTicket.Controllers
{
    public class PurchaseController : Controller
    {
        private readonly TicketContext _context;

        public PurchaseController(TicketContext context)
        {
            _context = context;
        }

        // GET: /<controller>/
        //[Authorize]
        public async Task<IActionResult> Index(string ID)
        {
            var info_event = await _context.Events
                .Include(e => e.Organizer)
                .FirstOrDefaultAsync(e => e.EventId == ID);
            if (info_event == null)
            {
                return Error();
            }
            var user = _context.Users.FirstOrDefault(u => u.Email == User.Identity.Name);
            ViewData["userName"] = user.FullName;
            ViewData["user"] = user;
            return View(info_event);
        }

        private IActionResult Error()
        {
            return View("Error");
        }

        public async Task<IActionResult> Charge(string stripeEmail, string stripeToken, string ID)
        {
            var info_event = _context.Events.FirstOrDefault(e => e.EventId == ID);
            if (info_event == null)
                return Error();
            var customers = new CustomerService();
            var charges = new ChargeService();

            var customer = customers.Create(new CustomerCreateOptions
            {
                Email = stripeEmail,
                SourceToken = stripeToken
            });

            var charge = charges.Create(new ChargeCreateOptions
            {
                Amount = Convert.ToInt32(info_event.Price) * 100,
                Description = "Event Purchase",
                Currency = "eur",
                CustomerId = customer.Id
            });

            if (ModelState.IsValid)
            {
                var user = _context.Users.FirstOrDefault(u => u.UserName == User.Identity.Name);
                var t = new Ticket { UserId = user.Id, EventId = ID };

                _context.Add(t);
                await _context.SaveChangesAsync();

                var ticket = _context.Tickets
                    .Include(tk => tk.User)
                    .Include(tk => tk.Event.Organizer)
                    .FirstOrDefault(tk => tk.TicketUUID == t.TicketUUID);

                return View(ticket);
            }

            return Error();
        }
    }

}

EpiTicket/Views/Event/Create.cshtml
@model EpiTicket.Models.Event

@{
    ViewData["Title"] = "Create";
}

<h1>Créer un événement</h1>

<hr />
<div class="row">
    <div class="col-md-4">
        <form asp-action="Create" enctype="multipart/form-data">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            <div class="form-group">
                <label class="control-label">Nom de l'évenement</label>
                <input asp-for="Name" class="form-control" />
                <span asp-validation-for="Name" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Poster" class="control-label"></label>
                <input type="file" asp-for="Poster" class="form-control-file" />
                <span asp-validation-for="Poster" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Description" class="control-label"></label>
                <input asp-for="Description" class="form-control" />
                <span asp-validation-for="Description" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Location" class="control-label"></label>
                <input asp-for="Location" class="form-control" />
                <span asp-validation-for="Location" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label class="control-label">Nombre de place</label>
                <input asp-for="Capacity" class="form-control" />
                <span asp-validation-for="Capacity" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label class="control-label"> Prix</label>
                <input asp-for="Price" class="form-control" />
                <span asp-validation-for="Price" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label class="control-label">Début de l'événement</label>
                <input asp-for="StartDate" class="form-control" />
                <span asp-validation-for="StartDate" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label class="control-label">Fin de l'événement</label>
                <input asp-for="EndDate" class="form-control" />
                <span asp-validation-for="EndDate" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label class="control-label">Nom de l'association</label>
                <select asp-for="AssociationId" class ="form-control" asp-items="ViewBag.AssociationId"></select>
            </div>
            <div class="form-group">
                <input type="submit" value="Create" class="btn btn-primary" />
            </div>
        </form>
    </div>
</div>

<div>
    <a asp-action="Index">Back to List</a>
</div>

@section Scripts {
    @{await Html.RenderPartialAsync("_ValidationScriptsPartial");}
}

EpiTicket/Views/Event/Delete.cshtml
@model EpiTicket.Models.Event

@{
    ViewData["Title"] = "Delete";
}

<h1>Supprimer @Model.Name</h1>

<h3>Êtes vous sûr de vouloir supprimer l'événement @Model.Name qui a lieu le @String.Format("{0:dd/MM/yyyy}", @Model.StartDate) à @String.Format("{0:HH:mm}", @Model.StartDate) ?</h3>
<div>
    <form asp-action="Delete">
        <input type="hidden" asp-for="EventId" />
        <input type="submit" value="Supprimer" class="btn btn-danger" /> |
        <a asp-action="Index">Annuler et retourner à la liste des associations</a>
    </form>
</div>

EpiTicket/Views/Event/Details.cshtml
@model EpiTicket.Models.Event
@using CloudinaryDotNet

@{
    ViewData["Title"] = "Détails de l'événement";
}

<h1>Détails de @Model.Name</h1>

<div>
    <hr />
    @if (Model.Poster == null)
    {
        @Html.Raw(EpiTicket.Data.Cloudinary.Instance.Api.UrlImgUp.Transform(new Transformation().Width(500).Height(300).Crop("fill").Radius("8")
                                                                       ).BuildImageTag("EpiTicket/placeholder-event", new CloudinaryDotNet.StringDictionary("alt=" + Model.Name)))
    }
    else
    {
        @Html.Raw(EpiTicket.Data.Cloudinary.Instance.Api.UrlImgUp.Transform(new Transformation().Width(500).Height(300).Crop("fill").Radius("8")
                                                                               ).BuildImageTag(Model.Poster, new CloudinaryDotNet.StringDictionary("alt=" + Model.Name)))
    }
    <dl class="row">
        <dt class="col-sm-2">
            Nom
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Name)
        </dd>
        <dt class="col-sm-2">
            Description
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Description)
        </dd>
        <dt class="col-sm-2">
            Lieu
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Location)
        </dd>
        <dt class="col-sm-2">
            Nombre de places
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Capacity)
        </dd>
        <dt class="col-sm-2">
            Prix
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Price)&euro;
        </dd>
        <dt class="col-sm-2">
            Début de l'événement
        </dt>
        <dd class="col-sm-10">
            @String.Format("{0:dd/MM/yyyy HH:mm}", Model.StartDate)
        </dd>
        <dt class="col-sm-2">
            Fin de l'événement
        </dt>
        <dd class="col-sm-10">
            @String.Format("{0:dd/MM/yyyy HH:mm}", Model.EndDate)
        </dd>
        <dt class="col-sm-2">
            Organisateur
        </dt>
        <dd class="col-sm-10">
            @Html.DisplayFor(model => model.Organizer.Name)
        </dd>
    </dl>
</div>
<div>
    <a asp-action="Edit" asp-route-id="@Model.EventId">Modifier</a> |
    <a asp-action="Index">Retourner à la liste des événements</a> |
    <a asp-action="Index" asp-controller="Purchase" asp-route-id="@Model.EventId">Acheter un ticket</a>
</div>

EpiTicket/Views/Event/Edit.cshtml
@model EpiTicket.Models.Event

@{
    ViewData["Title"] = "Edit";
}

<h1>Edit</h1>

<h4>Event</h4>
<hr />
<div class="row">
    <div class="col-md-4">
        <form asp-action="Edit" enctype="multipart/form-data">
            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
            <input type="hidden" asp-for="EventId" />
            <div class="form-group">
                <label asp-for="Name" class="control-label"></label>
                <input asp-for="Name" class="form-control" />
                <span asp-validation-for="Name" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Poster" class="control-label"></label>
                <input type="file" asp-for="Poster" class="form-control" />
                <span asp-validation-for="Poster" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Description" class="control-label"></label>
                <input asp-for="Description" class="form-control" />
                <span asp-validation-for="Description" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Location" class="control-label"></label>
                <input asp-for="Location" class="form-control" />
                <span asp-validation-for="Location" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Capacity" class="control-label"></label>
                <input asp-for="Capacity" class="form-control" />
                <span asp-validation-for="Capacity" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="Price" class="control-label"></label>
                <input asp-for="Price" class="form-control" />
                <span asp-validation-for="Price" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="StartDate" class="control-label"></label>
                <input asp-for="StartDate" class="form-control" />
                <span asp-validation-for="StartDate" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="EndDate" class="control-label"></label>
                <input asp-for="EndDate" class="form-control" />
                <span asp-validation-for="EndDate" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="AssociationId" class="control-label"></label>
                <select asp-for="AssociationId" class="form-control" asp-items="ViewBag.AssociationId"></select>
                <span asp-validation-for="AssociationId" class="text-danger"></span>
            </div>
            <div class="form-group">
                <input type="submit" value="Save" class="btn btn-primary" />
            </div>
        </form>
    </div>
</div>

<div>
    <a asp-action="Index">Back to List</a>
</div>

@section Scripts {
    @{await Html.RenderPartialAsync("_ValidationScriptsPartial");}
}

EpiTicket/Views/Event/Index.cshtml
@model IEnumerable<EpiTicket.Models.Event>
@using EpiTicket.Data
@using CloudinaryDotNet

@{
    ViewData["Title"] = "Liste des événements";
}

<div>
    <h1>Liste des événements</h1>

    <p>
        <a asp-action="Create">Créer un nouvel événement</a>
    </p>
</div>
@foreach (var item in Model)
{
    <div>
        <hr />
        @if (item.Poster == null)
        {
            @Html.Raw(EpiTicket.Data.Cloudinary.Instance.Api.UrlImgUp.Transform(
                                                 new Transformation().Width(500).Height(300).Crop("fill").Radius("8")
                                             ).BuildImageTag("EpiTicket/placeholder-event", new CloudinaryDotNet.StringDictionary("alt=" + item.Name)))
        }
        else
        {
            @Html.Raw(EpiTicket.Data.Cloudinary.Instance.Api.UrlImgUp.Transform(
                                                         new Transformation().Width(500).Height(300).Crop("fill").Radius("8")
                                                     ).BuildImageTag(item.Poster, new CloudinaryDotNet.StringDictionary("alt=" + item.Name)))
        }
        <h3>
            <a asp-action="Details" asp-route-id="@item.EventId">@Html.DisplayFor(modelItem => item.Name)</a>
        </h3>
        <p>
            Lieu : <b>@Html.DisplayFor(modelItem => item.Location)</b>
        </p>
        <p>
            Le @String.Format("{0:dd/MM/yyyy}", item.StartDate) à @String.Format("{0:HH:mm}", item.StartDate)
        </p>
        <p>
            Prix du billet : <b>@Html.DisplayFor(modelItem => item.Price) €</b>
        </p>
        <p>
            Organisé par <b>@Html.DisplayFor(modelItem => item.Organizer.Name)</b>
        </p>
        <p>
            <a asp-action="Edit" asp-route-id="@item.EventId">Modifier</a> |
            <a asp-action="Delete" asp-route-id="@item.EventId">Supprimer</a> |
            <a asp-action="Index" asp-controller="Purchase" asp-route-id="@item.EventId">Purchase</a>
        </p>
    </div>
}